package com.frist008.nixlibrary;

import android.net.Uri;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentActivity;
import android.support.v7.widget.RecyclerView;
import android.widget.AbsListView;
import android.widget.ExpandableListView;

import com.frist008.nixlibrary.utils.NixUri;

@SuppressWarnings("unused")
public class LoaderRecyclerBuilder extends NixLoaderBuilder {

	LoaderRecyclerBuilder(@NonNull FragmentActivity activity,
	                      @Nullable Fragment fragment, @NonNull Uri uri) {
		super(activity, fragment, uri);
	}

	@SuppressWarnings("unchecked")
	public CursorRecyclerLoader register(@NonNull RecyclerView recyclerView, int loaderId) {
		return new CursorRecyclerLoader(fragment,
		                                activity,
		                                recyclerView,
		                                loaderId,
		                                listenerBefore,
		                                listenerAfter,
		                                selectListener,
		                                uri,
		                                projection,
		                                sort,
		                                select,
		                                args);
	}

	public static LoaderRecyclerBuilder create(NixUri nixUri, @NonNull Fragment fragment) {
		return new LoaderRecyclerBuilder(fragment.getActivity(),
		                                 fragment,
		                                 nixUri.getUri());
	}

	public static LoaderRecyclerBuilder create(NixUri nixUri, @NonNull FragmentActivity activity) {
		return new LoaderRecyclerBuilder(activity, null, nixUri.getUri());
	}

	@Override
	public LoaderRecyclerBuilder projection(@Nullable String... projection) {
		super.projection(projection);
		return this;
	}

	@Override
	public LoaderRecyclerBuilder sortAsc(String filed, @Nullable String... fields) {
		super.sortAsc(filed, fields);
		return this;
	}

	@Override
	public LoaderRecyclerBuilder sortDesc(String filed, @Nullable String... fields) {
		super.sortDesc(filed, fields);
		return this;
	}

	@Override
	public LoaderRecyclerBuilder where(@NonNull String select, @NonNull String... args) {
		super.where(select, args);
		return this;
	}

	@Override
	public LoaderRecyclerBuilder where(@NonNull String select) {
		super.where(select);
		return this;
	}

	@Override
	public LoaderRecyclerBuilder setWhereListener(
			@NonNull OnChangeSelectCursorLoader selectListener) {
		super.setWhereListener(selectListener);
		return this;
	}

	@Override
	public LoaderRecyclerBuilder changeCursorBeforeListener(
			@NonNull OnChangeCursorBeforeListener ltn) {
		super.changeCursorBeforeListener(ltn);
		return this;
	}

	@Override
	public LoaderRecyclerBuilder changeCursorAfterListener(
			@NonNull OnChangeCursorAfterListener ltn) {
		super.changeCursorAfterListener(ltn);
		return this;
	}

	@Deprecated
	@Override
	public NixCursorLoader<AbsListView> register(@NonNull AbsListView listView, int loaderId) {
		return super.register(listView, loaderId);
	}

	@Deprecated
	@Override
	public NixCursorLoader<ExpandableListView> register(
			@NonNull ExpandableListView expandableListView, int loaderId) {
		return super.register(expandableListView, loaderId);
	}

	@Deprecated
	@Override
	public NixCursorLoader register(int loaderId) {
		return super.register(loaderId);
	}
}
